; ROUTINE TO RETURN COLOR OF A POINT ON A MEDIUM RES COLOR SCREEN
;
locate  proc    far
;
        push    bx              ; save registers
        push    cx
;
; multiply y-coord by bytes per row and adjust for even/odd lines
        mov     ax,di           ; get y-coord into low part
        mov     ah,al           ;  and into high part
        and     ax,01FEh        ; mask off unwanted parts
        sal     ax,1            ; times 4
        sal     ax,1            ; times 8
        sal     ax,1            ; times 16
        mov     bx,ax           ; goes into address
        and     bh,7            ; without adjustment
        sal     ax,1            ; times 32
        sal     ax,1            ; times 64
        add     bx,ax           ; address gets times 64 + times 16
;
; add x-coord to address
        mov     ax,si           ; get x-coordinate
        sar     ax,1            ; divide
        sar     ax,1            ;  by 4
        add     bx,ax           ; here is the address
;
; compute the position of the pixel in the byte
        mov     cx,si           ; use x-coord to determine count
        and     cx,3            ; just the bit count
        inc     cx              ; plus one
        sal     cx,1            ; 2 bit per pixel
;
; get the byte and rotate into place
        mov     al,es:[bx]      ; get old byte
        rol     al,cl           ; rotate left this many times
        and     ax,3            ; just the pixel color
;
        pop     cx              ; restore registers
        pop     bx
        ret
;
locate  endp




