; ROUTINE TO DETERMINE PITCH
;
; SEGMENTS REFERENCED:
; The data segment must contain the following pitch table
;
; notes         dw      4186    ; C
;               dw      4435    ; C# /Db
;               dw      4699    ; D
;               dw      4978    ; D# /Eb
;               dw      5274    ; E
;               dw      5588    ; F
;               dw      5920    ; F# /Gb
;               dw      6272    ; G
;               dw      6645    ; G# /Ab
;               dw      7040    ; A
;               dw      7459    ; A# /Bb
;               dw      7902    ; B
;
pitch   proc    far
;
        push    cx              ; save registers
        push    bx
        push    ax
;
        mov     ah,0            ; extend pitch number to 16 bits
        mov     cl,12           ; divide by 12
        div     cl              ; divide
;
        mov     dl,al           ; quotient determines the octave
        mov     al,ah           ; remainded is the pitch within
        cbw                     ; 16-bit needed for look up
        sal     ax,1            ; 2 bytes per item
        mov     bx,ax           ; into BX
        mov     cx,notes[bx]    ; look it up
        call    freq            ; convert the frequency
;
        xchg    cx,dx           ; octave in cl, period in DX
        neg     cl              ; 8 - octave = shift count
        add     cl,8
        sal     dx,cl
;
        pop     ax              ; restore registers
        pop     bx
        pop     cx
        ret
;
pitch   endp

