; ROUTINE TO READ BYTES FROM A FILE
;
;  Input:
;       BX contains file handle.
;       DS:DX points to a linear buffer where the bytes are to appear
;       CX contains the byte count
;  Output:
;       On success the bytes are read and the carry is clear.
;       Failure, the carry is set and error code is in AX
;  Registers used:
;       BX, CX and DX are used for input
;  Segments referenced:
;       Data segment must contain the linear byte buffer LBUFF.
;  Routines called:
;       DOS call 3Fh(read from a file)
;
readfile        proc    far
;
        mov     ah,3Fh          ; read from a file
        int     21h             ; DOS call
;
        cmp     ax,cx           ; everything back ?
        je      readfileexit    ; skip if ok
        mov     ax,22           ; not all read
        stc                     ; set carry if error
;
readfileexit:
        ret
;
readfile        endp
;

