; ROUTINE TO SAVE A FILE FROM COMMUNICATION LINE TO DISK
;
;  Function: see above
;  Input:
;       On entry the file specifier is in the unformatted parameter area
;       of the program segment prefix. This contains the tail of the command
;       line which invoked the SAVE command. During the routine input is from
;       the communications line which in this case is com2:  initialized as
;       2400 baud, even parity, 8-bit word, one stop bit.
;  Registers used: Many
;  Segments referenced:
;       On entry the segments must be as for entry to EXE files.
;  Routines called:
;       GETSPEC,CREATEFILE, CLOSEFILE,INITCBUFF,
;       INCBUFF, OUTCBUFF, COMINIT, COMON, EMESSOUT
;
;
        extrn   stdinck:far
        extrn   emessout:far,getspec:far
        extrn   createfile:far,closefile:far
        extrn   cominit:far,comon:far,comoff:far
        extrn   initcbuff:far,incbuff:far,outcbuff:far
        extrn   flushit:far
        extrn   dta:dword
;
;*****************************************************************************
;
datas   segment public
;
namebuff        db      256 dup(0)
;
datas    ends
;******************************************************************************
stacks  segment stack
        db      20 dup('stack   ')
stacks  ends
;******************************************************************************
codes   segment
;
        assume  cs:codes,ds:datas
;
; ROUTINE TO SAVE FILE FROM COMMUNICATION LINE TO DISK
;
save    proc    far
;
; set up return
        push    ds              ; save for proper return
        mov     ax,0            ; points to beginning of segment
        push    ax              ; for the offset
;
; set up segments
        mov     dx,ds           ; programsegment prefix was data seg
        mov     ax,datas        ; new data segment
        mov     ds,ax           ; put in DS
        mov     es,ax           ; put in ES
        mov     dta+2,dx        ; set the segment of the data
;
; set up the file
        lea     dx,namebuff     ; point to ASCIIZ buffer
        call    getspec         ; get file specifications
        jc      exception       ; error ?
        lea     dx,namebuff     ; ASCIIZ buffer has file specifiers
        call    createfile      ; set up file
        jc      execption       ; error ?
        mov     bx,ax           ; get the file handle
;
; set up the communications line
        mov     dx,1            ; for com2:
        mov     al,0BBh         ; 2400:e,8,1
        call    cominit         ; initialize it
        call    comon           ; turn it on
;
; initialize the buffer
        call    initcbuff       ; initialize the buffer
        mov     dx,1            ; com2:
;
; main loop for pulling in bytes
saveloop:
        call    incbuff         ; check for input
        jc      exception       ; error or end of file ?
        call    outcbuff        ; check to send it out
        jc      exception       ; error ?
        jmp     saveloop
;
; handle exceptions
exception:
        cmp     ax,19           ; end of file ?
        je      save1           ; if so close it up and return
;
        call    emessout        ; report this error
        jmp     saveexit        ; and return
;
; normal return
save1:
        call    comoff          ; com line off
        call    flushit         ; flush the buffer
        jc      exception       ; error ?
        call    closefile       ; close the file
        jc      exception       ; error ?
        jmp     saveexit        ; exit
;
; common return
saveexit:
        call    comon           ;com line on
        ret
;
save    endp
codes   ends                    ; out of code segment
        end     save
;
