; ROUTINE TO DRAW A LINE
;
setline proc    far
;
        push    bx              ; save registers
        push    cx
        push    dx
        push    si
        push    di
        push    ax
;
; set up x and y updates
        mov     si,1            ; start with positive 1 for x update
        mov     di,1            ; start with positive 1 for y update
;
; find |y2-y1|
        mov     dx,y2           ; get y2
        sub     dx,y1           ; subtyract y1
        jge     storey          ; skip if y2-y1 is nonnegative
        neg     di              ; move in negative y direction
        neg     dx              ; absolute value of y2-y1
storey:
        mov     deldy,di        ; store y update for diagonal moves
;
; find |x2-x1|
        mov     cx,x2           ; get x2
        sub     cx,x1           ; subtyract x1
        jge     storex          ; skip if x2-x1 is nonnegative
        neg     si              ; move in negative x direction
        neg     cx              ; absolute value of x2-x1
storex:
        mov     deldx,si        ; store x update for diagonal moves
;
; sort |y2-y1| and |x2-x1|
        cmp     cx,dx           ; compares dels with delp
        jge     setdiag         ; skip if straight moves in x direction
        mov     si,0            ; if straight=vertical: kill x update
        xchg    cx,dx           ;    and exchange differences
        jmp     storedelsxy
;
setdiag:
        mov     di,0            ; if straight=horizontal: kill y update
;
; store dels, delp, delsx, and delsy
storedelsxy:
        mov     dels,cx         ; change in straight direction
        mov     delp,dx         ; change in perpendicular to straight
        mov     delsx,si        ; x update in straight direction
        mov     delsy,di        ; y update in straight direction
;
; get intial values for x and y
        mov     si,x1           ; x-coordinate
        mov     di,y1           ; y-coordinate
;
; compute initial value and increments for error function
        mov     ax,delp
        sal     ax,1            ; 2*delp
        mov     delse,ax        ; change if straight move
;
        sub     ax,cx           ; 2*delp - dels
        mov     bx,ax           ; initial value
;
        sub     ax,cx           ; 2*delp - 2*dels
        mov     delde,ax        ; change if diagonal move
;
; adjust count
        inc     cx
;
; set the dolor
        mov     dx,color        ; get the color
;
; main loop structure
lineloop:
        call    setpt           ; plot the point
        cmp     bx,0            ; determine straight or diagonal move
        jge     diagonal
;
; case for straight move
straight:
        add     si,delsx        ; update x
        add     di,delsy        ; update y
        add     bx,delse        ; update error term
        loop    lineloop        ; next term
        jmp     lineexit
;
; case for diagonal move
        add     si,deldx        ; update x
        add     di,deldy        ; update y
        add     bx,delde        ; update error term
        loop    lineloop        ; next term
;
lineexit:
        pop     ax
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        ret
;
setline endp




